#!/bin/sh
# the next line restarts using tclsh \
exec wish "$0" "$@"

set w {}
set port 3001
fconfigure stdout -encoding binary -translation binary
frame $w.buttons
pack $w.buttons -side bottom -fill x -pady 2m
button $w.buttons.dismiss -text Dismiss -command "destroy $w"
pack $w.buttons.dismiss -side left -expand 1

text $w.text -relief sunken -bd 2 -yscrollcommand "$w.scroll set" -setgrid 1 -height 30 -undo 1 -autosep 1
scrollbar $w.scroll -command "$w.text yview"
pack $w.scroll -side right -fill y
pack $w.text -expand yes -fill both

proc showmsg msg {
    .text insert end "$msg \n"
    .text yview scroll 1 units
    puts $msg
}
$w.text insert end "ТЕСТ\n"

socket -server connect $port
proc connect {sock caddr cport} {
    global w
  fconfigure $sock -blocking no -encoding binary -translation binary
  # -buffering line
  fileevent $sock readable [list exchange $sock $caddr $cport]
  showmsg "Канехт : $caddr $cport"
}

proc exchange {sock caddr cport} {
    global w
    set text ""
  if {[catch {set text [read $sock]}] || [eof $sock]} {
    close $sock
    set text "Канехт клозед"
  } elseif {$text eq ""} {
  } else { puts -nonewline $sock "$text";flush $sock }
  showmsg "$text"
}
